using namespace std;

#include <iostream>
#include <assert.h>

#include "drawboard.h"
#include "players.h"
#include "checkmove.h"

int main(int argc, char *argv[])
{
  assert(argc == 3);
  InitPlayers(argv[1], argv[2]);

  InitXWindow(argc, argv);
  DrawBoard();

  SendInitialMessages();
  while (1) {
    HandleXEvent();

    int from, to, pathLen;
    MarblePosType path[121];
    ReadMove(1, from, to);
    long time = GetTimeUsed(1);
    cout << "Player 1: from " << from << " to " << to << " at "
      << time/100.0 << "s" << endl;

    assert(CheckAndMakeMove(1, from, to, path, pathLen));
    SendMove(2, from, to);
    DisplayMove(1, from, to, path, pathLen);

    ReadMove(2, from, to);
    time = GetTimeUsed(2);
    cout << "Player 2: from " << from << " to " << to << " at "
      << time/100.0 << "s" << endl;

    assert(CheckAndMakeMove(2, from, to, path, pathLen));
    SendMove(1, from, to);
    DisplayMove(2, from, to, path, pathLen);

    if (HasWon(1) && HasWon(2)) {
      cout << "A Draw\n";
      KillPlayers();
      return 0;
    }
    else if (HasWon(1)) {
      cout << argv[1] << " wins\n";
      KillPlayers();
      return 0;
    }
    else if (HasWon(2)) {
      cout << argv[2] << " wins\n";
      KillPlayers();
      return 0;
    }
  }
}







